﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.Pivot.Core;
using Telerik.Pivot.Core.Aggregates;
using Telerik.WinControls;

namespace _937489_RadPivoitList_SampleDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.radPivotFieldList1.FieldsControl.NodeFormatting+=new Telerik.WinControls.UI.TreeNodeFormattingEventHandler(FieldsControl_NodeFormatting);
            this.radPivotFieldList1.RowLabelsControl.VisualItemFormatting += new Telerik.WinControls.UI.VisualListItemFormattingEventHandler(RowLabelsControl_VisualItemFormatting);
            this.radPivotFieldList1.ColumnLabelsControl.VisualItemFormatting += new Telerik.WinControls.UI.VisualListItemFormattingEventHandler(ColumnLabelsControl_VisualItemFormatting);
        }

        void ColumnLabelsControl_VisualItemFormatting(object sender, Telerik.WinControls.UI.VisualItemFormattingEventArgs args)
        {
            var data = args.VisualItem.Data.DataBoundItem as Telerik.WinControls.UI.PivotFieldList.IField;
            if (data != null && data.FieldInfo.Name == "OrderID")
            {
                ((RadItem)args.VisualItem.Children[0]).Text = "Order ID";
            }
        }

        void RowLabelsControl_VisualItemFormatting(object sender, Telerik.WinControls.UI.VisualItemFormattingEventArgs args)
        {
            var data = args.VisualItem.Data.DataBoundItem as Telerik.WinControls.UI.PivotFieldList.ILabel;
            if (data != null && data.FieldInfo.Name == "OrderID")
            {
                ((RadItem)args.VisualItem.Children[0]).Text = "Order ID";
            }
        }

        void  FieldsControl_NodeFormatting(object sender, Telerik.WinControls.UI.TreeNodeFormattingEventArgs e)
        {
            if (e.Node.Text == "OrderID")
            {
                e.NodeElement.ContentElement.Text = "Order ID";
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'nwindDataSet.Orders' table. You can move, or remove it, as needed.
            this.ordersTableAdapter.Fill(this.nwindDataSet.Orders);
            this.radPivotGrid1.RowGroupDescriptions.Add(new DateTimeGroupDescription
            {
                PropertyName = "OrderDate",
                Step = DateTimeStep.Year,
                GroupComparer = new GroupNameComparer(),
                CustomName = "Order Date"
            });

            this.radPivotGrid1.ColumnGroupDescriptions.Add(new PropertyGroupDescription
            {
                PropertyName = "EmployeeID",
                GroupComparer = new GrandTotalComparer(),
                CustomName = "Employee ID"
            });

            this.radPivotGrid1.AggregateDescriptions.Add(new PropertyAggregateDescription
            {
                PropertyName = "Freight",
                AggregateFunction = AggregateFunctions.Sum,
                CustomName = "Freight"
            });

            this.radPivotGrid1.DataSource = this.ordersBindingSource;
        }
    }
}
